from byu_pytest_utils import max_score, with_import


def get_request_guard_domain(RequestGuard):
    guard = RequestGuard("https://cs111.byu.edu")
    # Mocking a different robots.txt
    guard.forbidden = ['/data', '/images', '/lectures']
    return guard


def get_request_guard_subdomain(RequestGuard):
    guard = RequestGuard("https://cs111.byu.edu/hw/hw07/")
    # Mocking a different robots.txt
    guard.forbidden = ['/data', '/images', '/lectures']
    return guard


def get_request_guard_offsite_domain(RequestGuard):
    guard = RequestGuard("https://code.visualstudio.com")
    # Mocking a different robots.txt
    guard.forbidden = ['/data', '/images', '/lectures']
    return guard


@max_score(17)
@with_import('RequestGuard', 'RequestGuard')
def test_request_guard_domain(RequestGuard):
    guard = get_request_guard_domain(RequestGuard)
    assert guard.can_follow_link('https://cs111.byu.edu/HW/HW01')
    assert guard.can_follow_link('https://cs111.byu.edu/Projects/Project4/images/cat.jpg')
    assert not guard.can_follow_link('https://byu.edu')
    assert not guard.can_follow_link('https://cs111.byu.edu/images/logo.png')
    assert not guard.can_follow_link('https://cs111.byu.edu/data/spectra1.txt')

    assert RequestGuard('https://cs111.byu.edu').forbidden == ['/proj/proj4/assets/page5.html']


@max_score(17)
@with_import('RequestGuard', 'RequestGuard')
def test_request_guard_subdomain(RequestGuard):
    guard = get_request_guard_subdomain(RequestGuard)
    assert guard.can_follow_link('https://cs111.byu.edu/HW/HW01')
    assert guard.can_follow_link('https://cs111.byu.edu/Projects/Project4/images/cat.jpg')
    assert not guard.can_follow_link('https://www.wikipedia.org')
    assert not guard.can_follow_link('https://cs111.byu.edu/images/logo.png')
    assert not guard.can_follow_link('https://cs111.byu.edu/data/spectra1.txt')

    assert RequestGuard('https://cs111.byu.edu/hw/hw07/').forbidden == ['/proj/proj4/assets/page5.html']


@max_score(16)
@with_import('RequestGuard', 'RequestGuard')
def test_request_guard_offsite_domain(RequestGuard):
    guard = get_request_guard_offsite_domain(RequestGuard)
    assert guard.can_follow_link('https://code.visualstudio.com/HW/HW01')
    assert guard.can_follow_link('https://code.visualstudio.com/Projects/Project4/images/cat.jpg')
    assert not guard.can_follow_link('https://www.jetbrains.com')
    assert not guard.can_follow_link('https://code.visualstudio.com/images/logo.png')
    assert not guard.can_follow_link('https://code.visualstudio.com/data/spectra1.txt')

    assert RequestGuard('https://code.visualstudio.com/hw/hw07/').forbidden == ['/raw']
